      program create_netcdf

      IMPLICIT none


      INTEGER llm,nbt
      INTEGER llh,nbth
      INTEGER llmf,nbtf
      INTEGER nbts
      INTEGER llmq,nbtq
      INTEGER llmw,nbtw
      INTEGER lm,nbstep
! llm, nbt: nb de niveaux et de pdt des champs moyens
! llmf, nbtf: nb de niveaux et de pdt des tendances
! nbts: nb de pdt des flux
! llmq, nbtq: nb de niveaux et de pdt de q1 et q2
! llmw, nbtw: nb de niveaux et de pdt de uw et vw
! lm,nbstep: dimensions du format netcdf

!     print*, 'Nombre de niveaux des champs moyens'
!     read(5,*) llm
!     print*, llm
!     print*, 'nombre de pas de temps des champs moyens'
!     read(5,*) nbt
!     print*, nbt
!     print*, 'Nombre de niveaux des advections'
!     read(5,*) llmf
!     print*, llmf
!     print*, 'nombre de pas de temps des advections'
!     read(5,*) nbtf
!     print*, nbtf
!     print*, 'nombre de pas de temps des flux'
!     read(5,*) nbts
!     print*, nbts
!     print*, 'Nombre de niveaux des q1 q2'
!     read(5,*) llmq
!     print*, llmq
!     print*, 'nombre de pas de temps des q1 q2'
!     read(5,*) nbtq
!     print*, nbtq
!
       llm=75
       nbt=1
       llh=76
       nbth=1
       llmf=75
       nbtf=48
       nbts=48
       llmq=75
       nbtq=48
       llmw=75
       nbtw=48
       lm=max(llm,llmf)
       print*,lm
       nbstep=max(nbt,nbtf,nbts)
       print*,nbstep
       CALL prepare_bomex(llm,nbt,llh,nbth,llmf,nbtf,nbts,llmq,nbtq,llmw,nbtw,lm,nbstep)

END


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      SUBROUTINE prepare_bomex(llm,nbt,llh,nbth,llmf,nbtf,nbts,llmq,nbtq,llmw,nbtw,lm,nbstep)
    

      IMPLICIT NONE

include "netcdf.inc"
include "YOMCST.h"
include "YOETHF.h"
      EXTERNAL suphel    ! initialiser certaines constantes

!Dimensions
!Fichiers etats moyens: llm, nbt
!Fichiers forçages: llmf, nbtf
!Fichiers flux de surface: nbts
!Fichiers de sortie: lm,nbstep

      INTEGER llm, nbt,nbt_autre
      INTEGER llmf, nbtf
      INTEGER nbts
      INTEGER llmq, nbtq
      INTEGER llmw, nbtw
      INTEGER lm,nbstep
      INTEGER l,k
      INTEGER llh,nbth

      INTEGER xm,ym
      PARAMETER(xm=1,ym=1)
!Variables lues
!Dates
      REAL*8 year(nbt),month(nbt),day(nbt)
      REAL*8 hour(nbt),time(nbt)
!     REAL*8 yearf(nbtf),monthf(nbtf),dayf(nbtf)
!     REAL*8 hourf(nbtf),timef(nbtf)
!     REAL*8 years(nbts),months(nbts),days(nbts)
!     REAL*8 hours(nbts),times(nbts)
!     REAL*8 yearq(nbtq),monthq(nbtq),dayq(nbtq)
!     REAL*8 hourq(nbtq),timeq(nbtq)
      REAL*8 time_out(nbstep)
      REAL*8 time_out_min,time_out_max
      
!Définition lon, lat
      REAL*8 lon(xm),lat(ym),zrho

!niveaux verticaux
      REAL*8 zz(llm,nbt),zzf(llmf,nbtf),zlev(lm,nbstep)
      REAL*8 ap(llh),bp(llh),pph(llh),zzh(llh)

!profils moyens lus
      REAL*8 th(llm,nbt),mwr(llm,nbt),u(llm,nbt),v(llm,nbt)
      REAL*8 pp(llm,nbt),qv(llm,nbt),T(llm,nbt),rh(llm,nbt)
      REAL*8 vent,uw(llmw,nbtw),vw(llmw,nbtw),ppw(llmw,nbtw)
      
!flux de surface lus
      REAL*8 flxs(nbts),flxl(nbts),ts(nbts),ps(nbts),orog

!forcages grande echelle lus
      REAL*8 ppf(llmf,nbtf),rho(llmf,nbtf)
      REAL*8 ug(llmf,nbtf),vg(llmf,nbtf),w(llmf,nbtf),omega(llmf,nbtf)
      REAL*8 du(llmf,nbtf),hu(llmf,nbtf),vu(llmf,nbtf)
      REAL*8 dv(llmf,nbtf),hv(llmf,nbtf),vv(llmf,nbtf)
      REAL*8 dT(llmf,nbtf),hT(llmf,nbtf),vT(llmf,nbtf),dtrad(llmf,nbtf)
      REAL*8 dq(llmf,nbtf),hq(llmf,nbtf),vq(llmf,nbtf)
      REAL*8 dth(llmf,nbtf),hth(llmf,nbtf),vth(llmf,nbtf)
      REAL*8 dr(llmf,nbtf),hr(llmf,nbtf),vr(llmf,nbtf)

!q1 q2 lus
      REAL*8 ppq(llmq,nbtq)
      REAL*8 qq1(llmq,nbtq),qq2(llmq,nbtq)

!Paramètres de forçages
      INTEGER tend_u,tend_v,tend_w,tend_t,tend_q
      INTEGER nudg_u,nudg_v,nudg_w,nudg_t,nudg_q
      
      REAL*8 XLVTT
      PARAMETER(XLVTT=2.5008E+6)

      REAL*8 ustar
      PARAMETER(ustar=0.28)

      REAL*8 pzero
      PARAMETER(pzero=1.e5)

!Variables intermédaires
      REAL*8 ppf_tmpv(lm,nbtf)
      REAL*8 ug_tmpv(lm,nbtf),vg_tmpv(lm,nbtf),w_tmpv(lm,nbtf)
      REAL*8 du_tmpv(lm,nbtf),hu_tmpv(lm,nbtf),vu_tmpv(lm,nbtf)
      REAL*8 dv_tmpv(lm,nbtf),hv_tmpv(lm,nbtf),vv_tmpv(lm,nbtf)
      REAL*8 dT_tmpv(lm,nbtf),hT_tmpv(lm,nbtf),vT_tmpv(lm,nbtf)
      REAL*8 dtrad_tmpv(lm,nbtf)
      REAL*8 dq_tmpv(lm,nbtf),hq_tmpv(lm,nbtf),vq_tmpv(lm,nbtf)
      REAL*8 dth_tmpv(lm,nbtf),hth_tmpv(lm,nbtf),vth_tmpv(lm,nbtf)
      REAL*8 dr_tmpv(lm,nbtf),hr_tmpv(lm,nbtf),vr_tmpv(lm,nbtf)      

      REAL*8 th_tmpv(lm,nbt),mwr_tmpv(lm,nbt),u_tmpv(lm,nbt),v_tmpv(lm,nbt)
      REAL*8 pp_tmpv(lm,nbt),qv_tmpv(lm,nbt),T_tmpv(lm,nbt),rh_tmpv(lm,nbt)

      REAL*8 ppq_tmpv(lm,nbtq),q1_tmpv(lm,nbtq),q2_tmpv(lm,nbtq)

      REAL*8 zz_tmpv(lm,nbt),zzf_tmpv(lm,nbtf)

!Variables ecrites dans fichier netcdf aux dimensions lm,nbstep
!profils moyen
      REAL*8 vitu(lm,nbstep),vitv(lm,nbstep)
      REAL*8 pres(lm,nbstep),ovap(lm,nbstep),temp(lm,nbstep),rhum(lm,nbstep)
!     REAL*8 theta(lm,nbstep),rv(lm,nbstep)     
      REAL*8 theta(lm,nbstep)     

!flux de surface
      REAL*8 flat(nbstep),sens(nbstep),tsurf(nbstep)

!forcages grande echelle
      REAL*8 vitug(lm,nbstep),vitvg(lm,nbstep),vitw(lm,nbstep)
      REAL*8 advT(lm,nbstep),T_advh(lm,nbstep),T_advv(lm,nbstep)
      REAL*8 radT(lm,nbstep)
      REAL*8 advq(lm,nbstep),q_advh(lm,nbstep),q_advv(lm,nbstep)   
      REAL*8 advth(lm,nbstep),th_advh(lm,nbstep),th_advv(lm,nbstep)
      REAL*8 advr(lm,nbstep),r_advh(lm,nbstep),r_advv(lm,nbstep)   
      REAL*8 advu(lm,nbstep),u_advh(lm,nbstep),u_advv(lm,nbstep)
      REAL*8 advv(lm,nbstep),v_advh(lm,nbstep),v_advv(lm,nbstep)  

      REAL*8 q1(lm,nbstep),q2(lm,nbstep)  

      REAL*8 timestep,dtm,dtf,dts
      REAL*8 day_init,month_init
      REAL*8 dayf_init,monthf_init
      REAL*8 days_init,months_init
      INTEGER nday,ndayf,ndays,ndayq

!Définition des sorties
      integer nbvar3d_out
      parameter (nbvar3d_out=39)
      character (len=50), dimension(nbvar3d_out) :: varname3d_out

      integer ierr
      
      integer :: londimout,latdimout
      integer :: altdimout,timedimout
!,timevarout
      integer :: nout

      integer var3didout(39),toto(lm)

      character*4 poub
      real*8 ppp(lm)

      CALL suphel
      print *,'Apres CALL suphel'

!     Read in data
!     read initial profiles

      ts(1)=300.375
      ps(1)=101500.
      orog=0.

      open(10,file='bomex.txt')
      open(20,file='profil_moy.txt')
! Combien de profils d environnement ?
      read(10,*) nbt
      nbt_autre=48
      write(20,*) nbt_autre
! Combien de niveaux ?
      read(10,*) llm
      write(20,*) llm
      do l=1,nbt
          read (10,*) year(l),month(l),day(l),hour(l)
          write(20,*) year(l),month(l),day(l),hour(l)
          do k=1,llm
           read(10,*) zz(k,l),th(k,l),T(k,l),qv(k,l),u(k,l),v(k,l),pp(k,l),mwr(k,l)
           rh(k,l)=0.
           write(20,*) pp(k,l),zz(k,l),u(k,l),v(k,l),T(k,l),th(k,l),qv(k,l),mwr(k,l),mwr(k,l),rh(k,l)
           write(*,*) pp(k,l),zz(k,l),u(k,l),v(k,l),T(k,l),th(k,l),qv(k,l),mwr(k,l),mwr(k,l),rh(k,l) 
          enddo
      enddo
! Meme s il n y a qu un seul profil initial, on le repete autant que les
! forcages
      do l=2,nbtf
          write(20,*) year(1),month(1),day(1),(l-1)*1800.
!         write(*,*) year(1),month(1),day(1),(l-1)*1800.
          do k=1,llm
           write(20,*) pp(k,1),zz(k,1),u(k,1),v(k,1),T(k,1),th(k,1),qv(k,1),mwr(k,1),mwr(k,l),rh(k,1)
          enddo
      enddo
      close(10)
      close(20)
      print *,'Profil initial: nbt,llm',nbt,llm

      open(10,file='cab.txt')
      open(20,file='coord_a_b.txt')
      read(10,*) nbth
      write(20,*) nbth
      read(10,*) llh
      write(20,*) llh
      do k=llh,1,-1
         read(10,*) ap(k),bp(k)
! c'est plus precis de recalculer pph que de prendre celui qui est dans le
! fichier
         ap(k)=ap(k)
!        pph(k)=ap(k)+bp(k)*ps(1)
         pph(k)=ap(k)
!        print *,'ap,bp,pph=',k,ap(k),bp(k),pph(k)
      enddo
      do k=1,llh
         write(20,*) ap(k),bp(k),pph(k)
!        print *,'ap,bp,pph=',k,ap(k),bp(k),pph(k)
      enddo
      close(10)
      close(20)

!read tendencies
!-------------------------------
! TEND A B C D E
! A=1 on utilise tendances sur U
! B=1 on utilise tendances sur V
! C=1 on utilise tendances sur W
! D=1 on utilise tendances sur theta
! E=1 on utilise tendances sur vapeur eau
!-------------------------------
! NUDG A B C D E
! A= U est nudge avec un temps de relaxation de A
! B= V est nudge avec un temps de relaxation de B
! C= W est nudge avec un temps de relaxation de C
! D= theta est nudge avec un temps de relaxation de D
! E= vapeur d'eau est nudgee avec un temps de relaxation de E
! si A,B,C,D,E=0 => pas de nudging
! si A,B=-1 => nudging avec vent geostrophique fourni
!-------------------------------
      open(11,file='profil_adv.txt')
! Lecture des flags de tendances
! tend_u,tend_v,tend_w,tend_t,tend_q
!     write(11,*) 'TEND      0      0      1      1      1'
! Lecture des flags de nudging
! nudg_u,nudg_v,nudg_w,nudg_t,nudg_q
!     write(11,*) 'NUDG   1800   1800      0      0      0'
! Combien de profils de forcing : toutes les demi heures pendant 24h
      write(11,*) nbtf
! Combien de niveaux : autant que pour les profils initiaux
      write(11,*) llmf
! Lecture des profils
      do l=1,nbtf
          write (11,*) year(1),month(1),day(1),l*1800.
          do k=1,llmf
             ppf(k,l)=pp(k,1)
             zzf(k,l)=zz(k,1)
             ug(k,l)=-10.+0.0018*zzf(k,l)
             vg(k,l)=0.
             if (zzf(k,l).LE.1500.) THEN 
                w(k,l)= (-0.0065/1500.)*zzf(k,l)
             elseif ((zzf(k,l).GT.1500.).AND.(zzf(k,l).LE.2100.)) THEN 
                w(k,l)= -0.0065+0.0065/(2100.-1500.)*(zzf(k,l)-1500.)
             else 
                w(k,l)=0.
             endif
             rho(k,l)=ppf(k,l)/T(k,1)/RD    ! conversion m/s en Pa/s
             omega(k,l)=-1.*w(k,l)*rho(k,l)*RG
             du(k,l)=0.
             hu(k,l)=0.
             vu(k,l)=0.
             dv(k,l)=0.
             hv(k,l)=0.
             vv(k,l)=0.
!            dT(k,l)=0.
             hT(k,l)=0.
             vT(k,l)=0.
             if (zzf(k,l).LE.1500.) THEN 
                dth(k,l)= -2.315e-5
             elseif ((zzf(k,l).GT.1500.).AND.(zzf(k,l).LE.2500.)) THEN 
                dth(k,l)= -2.315e-5+2.315e-5/(2500.-1500.)*(zzf(k,l)-1500.)
!?              dth(k,l)=dtrad(k,l)
             else 
                dth(k,l)=0.
             endif
!----------------------------------------------
! Le cas est force est theta, on convertit dth,hth,vth
! (adv totale, adv horizontale et adv verticale) en dt,ht,vt
! teta=temp*(pzero/play)**rkappa
!----------------------------------------------
             dT(k,l)=dth(k,l)/(pzero/ppf(k,l))**rkappa
             if (zzf(k,l).LE.300.) THEN 
                dq(k,l)= -1.2e-8
                hq(k,l)= -1.2e-8
             elseif ((zzf(k,l).GT.300.).AND.(zzf(k,l).LE.500.)) THEN 
                dq(k,l)= -1.2e-8 +1.2e-8/(500.-300.)*(zzf(k,l)-300.)
!?              dq(k,l)=dq(k,l)
                hq(k,l)= -1.2e-8 +1.2e-8/(500.-300.)*(zzf(k,l)-300.)
!?              hq(k,l)=hq(k,l)
             else 
                dq(k,l)=0.
                hq(k,l)=0.
             endif
                vq(k,l)=0.
                hth(k,l)=0.
                vth(k,l)=0.
                dr(k,l)=0.
                hr(k,l)=0.
                vr(k,l)=0.
             write(11,*) ppf(k,l),zzf(k,l),ug(k,l),vg(k,l),w(k,l),omega(k,l),du(k,l),hu(k,l),vu(k,l) &
     &                 ,dv(k,l),hv(k,l),vv(k,l),dT(k,l),hT(k,l),vT(k,l),dtrad(k,l),dq(k,l) &
     &                 ,hq(k,l),vq(k,l),dth(k,l),hth(k,l),vth(k,l),dr(k,l),hr(k,l),vr(k,l) 
             print *,'dq,hq=',dq(k,l),hq(k,l)
          enddo
      enddo
      close(11)

!Lecture des flux
      open(12,file='time_flux.txt')
! Combien de flux?
      write(12,*),nbts
      zrho= pp(1,1)/rd/T(1,1)
! On multiplie les flux par -1 (MPL 20150618)
! Non ! (MPL 20170522)
      flxs(1)=8e-3*rcpd*zrho
      flxl(1)=5.2e-5*rlvtt*zrho
      do l=1,nbts
         write(12,*) year(1),month(1),day(1),l*1800.,flxs(1),flxl(1),ts(1),ustar,ps(1),orog
!        print *,'pp,T,sens,flat',pp(1,l),T(1,l),flxs(l),flxl(l)
      enddo
      close(12)

!     read Q1, Q2

      open(13,file='q1_q2.txt')
! Combien de profils de q1 q2 ?
      write(13,*),nbtq
! Combien de niveaux ?
      write(13,*),llmq
      do l=1,nbtq
          write (13,*) year(1),month(1),day(1),l*1800.
          do k=1,llmq
             ppq(k,l)=pp(k,1)
             qq1(k,l)=0.
             qq2(k,l)=0.
             write(13,*) ppq(k,l),qq1(k,l),qq2(k,l)
          enddo
      enddo
      close(13)

      open(14,file='uw_vw.txt')
! Combien de profils de q1 q2 ?
      write(14,*),nbtq
! Combien de niveaux ?
      write(14,*),llmq
      do l=1,nbtq
          write (14,*) year(1),month(1),day(1),l*1800.
          do k=1,llmq
             ppw(k,l)=pp(k,1)
             vent=sqrt(u(k,1)*u(k,1)+v(k,1)*v(k,1))
             uw(k,l)=-u(k,1)*ustar*ustar/vent
             vw(k,l)=-v(k,1)*ustar*ustar/vent
             write(14,*) ppw(k,l),uw(k,l),vw(k,l)
          enddo
      enddo
      close(14)

     stop
     end
