#!/bin/bash

#-----------------------------------------------------------
# fichier filehf.nc on donne les "bons noms" de variables
# si un nom ne figure pas c est qu il porte le meme nom dans
# filehf.nc et histhf.nc
#-----------------------------------------------------------


ncdump -h hourly.nc | grep -i float | sed -e 's/(/ /' | cut -d' ' -f2 >| tmp_list_var

vars=""
for var in zfull zhalf pres paprs temp theta ovap oliq vitu vitv LWdnSFC LWupSFC SWdnSFC SWupSFC sens flat evap evu ustar precip psol tsol s_pblh alb1 z0m z0h t2m q2m rh2m u10m v10m cldt rneb rneblsvol rsd rsu rld rlu f_th mc dtthe dtswr dtlwr dtcon dtvdf dtlsc dteva dqthe dqcon dqvdf dqlsc dqeva tke ; do
  if [ "`grep '^'$var'$' tmp_list_var`" != "" ] ; then
      vars="$vars,$var"
  fi
done
ncks -v time_counter,presnivs,geop$vars  hourly.nc -O tmp0.nc

ncap2 -s 'zf=geop/9.81' -s 'rho=pres/(289*temp)' tmp0.nc -O tmp.nc
if [ "`grep '^'dtlwr'$' tmp_list_var`" != "" ] ; then ncap2 -s 'dtdt_rad=dtlwr+dtswr' tmp.nc -O tmp0.nc ; mv -f tmp0.nc tmp.nc ; fi
if [ "`grep '^'dqlsc'$' tmp_list_var`" != "" ] ; then ncap2 -s 'dqtdt_ls=dqlsc+dqeva'" ;  mv -f tmp0.nc tmp.nc ; fi
if [ "`grep '^'dtlsc'$' tmp_list_var`" != "" ] ; then ncap2 -s 'dttdt_ls=dtlsc+dteva'" ;  mv -f tmp0.nc tmp.nc ; fi

ncatted -O -a _FillValue,,d,, tmp.nc
ncrename -d time_counter,time \
         -v time_counter,time \
         -d presnivs,levf \
         -v presnivs,levf \
	 tmp.nc


# atonce est une cle introduite momentanement pour un probleme de bug nco
# qui n'arrive pas a traiter d'un coup plusieurs ncrename.
# atonce=1 , on essaie de les faire d'un coup (pour que ca tourne plus vite)
# atonce=0 , on fait la modif variable par variable. Plus sur mais plus lent
atonce=0
tobechanged=""
for paire in \
          pres,pf \
          zhalf,zh \
          paprs,ph \
          ovap,qv \
          oliq,ql \
          vitu,u \
          vitv,v \
          LWdnSFC,lwdw \
          LWupSFC,lwup \
          SWdnSFC,swdw \
          SWupSFC,swup \
          sens,shf \
          flat,lhf \
          precip,rain \
          psol,psurf \
          tsol,tsurf \
          s_pblh,hpbl \
          alb1,alb \
          cldt,cc \
          rsd,sw_dn \
          rsu,sw_up \
          rld,lw_dn \
          rlu,lw_up \
          dtswr,dtdt_swrad \
          dtlwr,dtdt_lwrad \
          dtthe,dtdt_shcon \
          dqthe,dqtdt_shcon \
          dtcon,dtdt_conv \
          dqcon,dqtdt_conv \
          dqvdf,dqtdt_turb ; do
          var=`echo $paire | cut -d, -f1`
	  if [ "`grep '^'$var'$' tmp_list_var`" != "" ] ; then
              if [ $atonce = 1 ] ; then
	          tobechanged="$tobechanged -v $paire"
              else
echo TOBECHANGED $paire
	          ncrename -v $paire tmp.nc
              fi
          fi
done
if  [ $atonce = 1 ] ; then ncrename $tobechanged tmp.nc ; fi

if [ 1 = 0 ] ; then
	# WAS crashing on some simulations when a variable was not present
	#to be checked in loop as other variables above
#ncrename $tobechanged tmp.nc
#       -a calendar,time,o,c,'365_day' \
#        -a standard_name,pf,o,c,'pressure at full level' \
#       -a standard_name,zh,o,c,'height half' \
#       -a long_name,zh,o,c,'height of half level' \
#       -a long_name,ph,o,c,'Half vertical levels' \
#       -a long_name,u10m,o,c,'10m u-component wind' \
#       -a standard_name,u10m,o,c,'10m u-component wind' \
#       -a long_name,v10m,o,c,'10m v-component wind' \
#       -a standard_name,v10m,o,c,'10m v-component wind' \
#       -a long_name,rain,o,c,'rainfall rate' \
#       -a standard_name,rain,o,c,'rainfall rate' \
#       -a long_name,cc,o,c,'total cloud cover fraction' \
#       -a standard_name,cc,o,c,'total cloud cover fraction' \
#       -a long_name,dtdt_rad,o,c,'Radiative tendency' \
#       -a standard_name,rho,o,c,'rho' \
ncatted -a title,levf,o,c,'levf' \
        -a long_name,levf,o,c,'Full vertical levels' \
        -a coordinates,,o,c,'time levf lat lon' \
        -a standard_name,zf,o,c,'height full' \
        -a long_name,zf,o,c,'height of full level' \
        -a long_name,rho,o,c,'Density' \
        -a units,rho,o,c,'kg/m3' \
        -a long_name,dtdt_swrad,o,c,'temperature tendency from short wave radiation' \
        -a standard_name,dtdt_swrad,o,c,'temperature tendency from short wave radiation' \
        -a long_name,dtdt_lwrad,o,c,'temperature tendency from long wave radiation' \
        -a standard_name,dtdt_lwrad,o,c,'temperature tendency from long wave radiation' \
        -a long_name,dtdt_ls,o,c,'Temperature tendency from large scale forcings' \
        -a standard_name,dtdt_ls,o,c,'Temperature advection' \
        -a long_name,dtdt_ls,o,c,'temperature advection' \
        -a standard_name,dtdt_ls,o,c,'temperature advection' \
        -a long_name,dqtdt_ls,o,c,'Moisture tendency from large scale forcings' \
        -a standard_name,dqtdt_ls,o,c,'Moisture advection' \
        -a long_name,tke,o,c,'turbulent kinetic energy' \
        -a standard_name,tke,o,c,'turbulent kinetic energy' \
        -h -a author,global,o,c,'MP Lefebvre' \
        -h -a history,global,o,c,'history goes here' \
        -h -a physics,global,o,c,`pwd` -O tmp.nc
fi

ncks -v dtlsc,dteva,dqlsc,dqeva -x -O tmp.nc hourly_std.nc
#-----------------------------------------------------------
# On change les noms des fichiers tmp.nc et tmp.nc
#rm -rf tmp*nc
